//#include <EthernetENC.h>
#include <SPI.h>
//#include <UIPEthernet.h>
#include <Ethernet.h>
// set value
String LogerID = "TNLG001"; //7 char only
int maxcomretry = 90;
int Bat145 = 744;// analogRead(5) for battery 14.5 volts
int mKirim = 10; // jangka sampling, dan kirim = 3 x sampling)

//runtime variable
unsigned long DCount[10] = {0,0,0,0,0,0,0,0,0,0};
boolean DLast[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned long secTimeBase = 0;
unsigned long lastime = 0;
unsigned long comstartime = 0;
unsigned long AnRead =0;
String sCom ;
String sCom1 ;
String sCom2 ;
int constatus = 0;
int comretry = 0;
int uBaca = 0;

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};

//IPAddress ip(192, 168, 1, 211);
// Enter the IP address of the server you're connecting to:
IPAddress server(202, 152, 39, 218);

// Initialize the Ethernet client library
// with the IP address and port of the server
EthernetClient client;

void(*resetFunc)(void)=0; //reset function @ address 0

void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("STARTING");
  
}

void loop () {
  sComRead();
  ComSend();
  Serial.println("next " + String((60*mKirim)-90));
  mydelay((60*mKirim)-90);
  // baca S1
  SavesCom();
  // baca S2
  SavesCom();
}

void ComSend() {
  comstartime = millis();
  comretry = 0;
  SetModemON();
  // if you get a connection, report back via serial:
  constatus = client.connect(server, 6013);
  while ((constatus != 1)&&(comretry < maxcomretry)) {
    Serial.println("fail " + String(constatus) + " retry " + String(comretry));
    comretry = comretry + 1;
    mydelay(1);
    constatus = client.connect(server, 6013);
    if (comretry >= maxcomretry) {
      // matikan modem
      SetModem(LOW);
      Serial.println("Skip");
    }
  }
  if (constatus == 1) {
    Serial.println("connected");
  }

  if (client.connected()) {
    sCom = sCom2 + sCom1 + sCom ;
    sCom = sCom + "MR-" + String((millis()-comstartime)/1000) + ";";
    sCom = sCom + LogerID ; // End transmission with loger ID  
    if (sCom.startsWith("A0-") != 1) {
      resetFunc();    
    }
    Serial.println(sCom);
    client.print(sCom);
    client.stop();
    Serial.println("send " + String(millis()-comstartime) + " mS");
    comretry = 0;
    // matikan modem
    SetModem(LOW); 
   }
}

void SavesCom() {
  sComRead();
  SetModem(LOW);  // segera matikan sensor
  // shift save
  sCom2 = sCom1;
  sCom1 = sCom;
  Serial.println("next " + String((60*mKirim)));
  mydelay(60*mKirim);
}

void mydelay(int detik) {
  for (int pin=1; pin<=detik; pin++) {
    msecdelay(1000);  
    Serial.print(String(pin) + ".");    
    if ((millis()/60000) > 9000) {
      resetFunc();    
    }
  }
  Serial.println(" ");

}

void msecdelay(unsigned long mDetik) {
  // baca counter digital hingga transmisi serial berikutnya
  lastime = millis();
  uBaca = 0;
  while (millis()  < (lastime + mDetik)) {
    uBaca++;
    //reset jika milis kembali 0
    if (millis() < lastime) {lastime = millis();}
    // read digital value
    for (int pin=5; pin<=9; pin++) {
      pinMode(pin, INPUT);
      boolean DigiState = digitalRead(pin);
      // count when state change high to low
      if ((DLast[pin-2] == HIGH) and (DigiState == LOW))
      {
        DCount[pin-2] = DCount[pin-2] + 1;
      }
      DLast[pin-2] = DigiState;
    }
  }
  // Serial.println("uBaca " + String(uBaca));
}

void SetModem(boolean bStatus) {
  pinMode(2, OUTPUT);
  digitalWrite(2, bStatus);
}

void SetModemON() {
  CheckBat();
  //if battery > 10V
  if (analogRead(5) > (10*Bat145/14.5)) {
     SetModem(HIGH);
     Serial.println("PowerUp modem");
     mydelay(20); //wait for modem to be ready
     Serial.println("Init Eth");     
     // You can use Ethernet.init(pin) to configure the CS pin
     Ethernet.init(10);  // Most Arduino shields
     // start the Ethernet connection:
     // Ethernet.begin(mac, ip);
     Ethernet.begin(mac);
     Serial.println("connect router");
     mydelay(10);
     Ethernet.maintain();
     Serial.print(Ethernet.localIP());
     Serial.println(" connect server 20s");
    // give the Ethernet shield a second to initialize:
    mydelay(20);
  } 
}

void CheckBat() {
  // when battery low, wait until battery rise
  while (analogRead(5) <= (11*Bat145/14.5)) {
     Serial.println("Bat Lo, idle 30m");
     mydelay(30*60); 
  }  
  Serial.print("Batt " + String(analogRead(5)) + " ");
  Serial.println(String(((analogRead(5)*14.5/Bat145))));
}

void sComRead() {
   CheckBat();
   SetModem(HIGH); //activate sensor
   mydelay(3);
      sCom = "";
      // read the analog in value:
      for (int pin=0; pin<=2; pin++) {
        // cleaning last reading
        for (int ulang=0; ulang<=10; ulang++) {
          AnRead = analogRead(pin);
          delay(2);
        }
        AnRead = 0;
        for (int ulang=1; ulang<=5; ulang++) {
          AnRead = analogRead(pin)+ AnRead;
          delay(1);
        }
        AnRead = AnRead / 5;
        sCom = sCom + "A" + String(pin) + "-" + String(AnRead) + ";";
      } 
    // digital value
      sCom = sCom + "D-";
    // in D5-D9 
      for (int pin=5; pin<=7; pin++) {
        sCom = sCom + String(digitalRead(pin));
      }
    sCom = sCom + ";" ;
    // digital counter 
      for (int pin=5; pin<=7; pin++) {
        sCom = sCom + "C" + String(pin) + "-" + String(DCount[pin-2]) + ";";
      }
    sCom = sCom + "BT-" + String(((analogRead(5)*14.5/Bat145)*10),0) + ";";
    sCom = sCom + "TM-" + String(millis()/60000) + ";";
    Serial.println(sCom);
}
